Subject: Re: FVWM: Non iso8995-1 fonts and the TaskBar

From: John Latham <[email-masked]>
Date: Thu, 5 Sep 2002 18:10:55 +0100

> From: Olivier Chapuis <[email-masked]>
> To: [email-masked]

> On Mon, Aug 12, 2002 at 06:29:28PM +0100, John Latham wrote:
> > FvwmTaskBar crashes, quietly without any trace, in 2.4.6 as shipped by Red Hat
> > 7.3 (multi-byte is enabled) and also in 2.4.8 when compiled with multibyte
> > option, but not otherwise.
 ....

> There is a bug in the taskbar, if the SelFont is not found the taskbar
> exit (the "default" font is not tried!). This will be fixed in the next
> stable release. Any way if you use:

> 	-*-*helvetica-medium-r-*-*-12-*-*-*-*-*-*-*
> 	 ^^
>
> I think that the taskbar will work as you want (no locale change and this
> is better than enforcing the charset).

Indeed, you are right -- it works, thanks. I must admit that I have not
fiddled with the fonts in AnotherLevelUp since it was Red Hat's AnotherLevel,
but I have previously noticed the `missing *' and believed it not to be a
problem. Which it isn't, apart from in FVWM 2.4!

> I still do not understand why with
> 	"-*helvetica-medium-r-*-*-12-*-*-*-*-*-*-*"
> the font loading procedure fails (as xlsfont show me some fonts, but
> xlsfont do not use the "i18n" procedure for querying font).
> But I do not think that it is fvwm fault. Maybe a "*" count issue.

I think you are saying it should not cause a problem, as stars are supposed to
match hyphens too. Which is what I believed to be true. The `missing -*' does
not cause a problem in FVWM 2.2.4 nor 2.5.{2,3}, just in 2.4.{6,8}. So,
perhaps FVWM 2.4 is querying fonts in a slightly different way?

> > ....

> Use "-*-*helvetica-medium-r-*-*-12-*-*-*-*-*-*-*"

I will thanks, -- I prefer your fix to mine. This might have other
consequences as Red Hat's AnotherLevel had (and so ALU currently still has):

	define(`BASIC_FONT',`*helvetica')

and then later on things like:

	*FvwmTaskBarFont -BASIC_FONT-medium-r-*-*-FONT_SIZE-*-*-*-*-*-*-*

and (now updated to use Style *)

	Style * Font BASIC_FONT-bold-r-*-120-*

etc., so I need to be a bit careful.

>
> > All this seems to work fine on 2.5.2, no need for locale change or iso8859-1
> > specification.
> > 
> > This all makes me think I could do with learning a *bit* more about X fonts
> > and their relationships to locales. Can anyone suggest a good (implies
> > short...) summary on the matter?
> > 
>
> "man XCreateFontSet" and the xlfd and i18nFramework documents in the X doc
> directory (something like /usr/X11R6/lib/X11/doc). Maybe you will not
> find this docs "good".

I shall try these, thanks.

> Regards, Olivier

Best wishes, John Latham
--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: Olivier Chapuis <[email-masked]>
Date: Fri, 6 Sep 2002 09:14:55 +0200

> perhaps FVWM 2.4 is querying fonts in a slightly different way?

I do not think that 2.2.x has i18n support. 2.4.x simply uses the X
i18n interface (with enable-multibyte). What happen is that
XCreateFonSet (an Xlib i18n function) does not load
"-*helvetica-medium-r-*-*-12-*-*-*-*-*-*-*" as XLoadQueryFont
(a "simple" Xlib function) load a font in this case.  In 2.5.x
things are more complex. I do not think that we should do someting
special in 2.4.x.

Reagards, Olivier